import random
collaborators = 'Your collaborators here'

# Enter some numerical value for each part of problem 1.

answer_for_problem_1_part_a = 1 # Merge sort is always Theta(n log n)
answer_for_problem_1_part_b = 3 # There are Theta(n^3) buckets
answer_for_problem_1_part_c = 1 # Use counting sort 3 times to reduce it to Theta(n) time

# Enter your answer to problem 2 here. 
answer_for_problem_2 = '''

DESCRIPTION

Suppose m is the median value.

Then if there are exactly i elements less than m in X, there must be exactly n-i elements less than m in Y.
So X[i-1] <= m <= X[i] and Y[n-i-1] <= m <= Y[n-i]

Since X and Y are sorted, we have that:
  -  If k > i, then X[k] >= m >= Y[n-k-1]
  -  If k < i, then Y[n-k] >= m >= X[k-1]
Thus it is easy to check if k is too high or low, by comparing X[k-1], X[k], Y[n-k-1], and Y[k].

Thus we can binary search to find i, which then lets us recover the median.

PSEUDOCODE (OPTIONAL)

start, end = 0, n - 1
while True:
  k = (start + end) / 2
  if X[k] > Y[n-k-1]:
    end = k
    continue
  elif Y[n-k] > X[k-1]:
    start = k
    continue
  else:
    return (max(X[k-1], Y[n-k-1]) + min(X[k], Y[n-k])) / 2

ANALYSIS

Correctness:  Follows from the discussion above

Runtime:  Is the same as the runtime of binary search, Theta(log n).
We cut down the interval of possible i values by half each time,
doing constant work each iteration.  

'''

# Enter your answer to problem 3 here. 
answer_for_problem_3 = '''

DESCRIPTION

We do a modified BFS on each connected component.  The modification is simply that when we
explore a non-tree edge, we check that the parity of the distances to the endpoints is different.
If not, we immediate return YES.  Otherwise, if all the BFSes complete, return NO.

ANALYSIS

Correctness:

Suppose there is an odd cycle.  Then, there are two adjacent vertices with equal parity
(otherwise, all adjacent vertices have different parity, but if the cycle has length (2k+1),
we see that v_1 has the same parity as v_3, v_5, ... v_(2k+1).  This is a contradiction,
since v_1 connects to v_(2k+1)).  Since a BFS looks at all edges, we will find this edge
between two vertices of equal parity, and return YES, as desired.

Suppose we return YES.  So we found an edge e = (v, w) between vertices with equal parity
of distance from the source s. The distances must be equal, since the edge e means the
distances differ by at most one.  Consider a shortest path from s to v, and one from s to w.
Neither path contains e = (v, w), since the paths are SHORTEST paths of equal length.
Let t be the furthest (away from s) vertex at which the paths intersect (possibly equal to s).
Then the path from t to v, and from t to w, are disjoint, and are the same length (since we
removed identical sub-paths).  So combining the two gives an even length path from v to w.
And since it doesn't use e = (v, w), adding the edge e shows that the graph had an odd cycle.

Thus we return YES if and only if there is an odd cycle.

Runtime:

The runtime is simply that of BFS, O(E+V), since our check takes constant time.

'''

# Your answer to each part should be the character 'B', or the character 'D'
answer_for_problem_4_part_a = 'D'
answer_for_problem_4_part_b = 'B'
answer_for_problem_4_part_c = 'B'
answer_for_problem_4_part_d = 'D'
answer_for_problem_4_part_e = 'B'

# Your answer to each part should be a boolean. 
answer_for_problem_5_part_a = True
answer_for_problem_5_part_b = False
answer_for_problem_5_part_c = False
answer_for_problem_5_part_d = False
answer_for_problem_5_part_e = False
answer_for_problem_5_part_f = True
answer_for_problem_5_part_g = False
answer_for_problem_5_part_h = True
answer_for_problem_5_part_i = True
answer_for_problem_5_part_j = True

def find_distances(graph, sources):
  distances = {node: None for node in graph}
  visited = set(sources) 
  i = 0
  while sources:
    newsources = []
    for v in sources:
      distances[v] = i
      for w in graph[v]:
        if w not in visited:
          visited.add(w)
          newsources.append(w)
    i += 1
    sources = newsources
  return distances
  
